Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
CConstrainPosInterval Class Reference

A constraint interval that will constrain the position of one node to the position of another. More...

`#include "cConstrainPosInterval.h"`

Inheritance diagram for CConstrainPosInterval:

## Public Member Functions
| CConstrainPosInterval (const std::string &name, double duration, const NodePath &node, const NodePath &target, bool wrt, const LVecBase3 posOffset=LVector3::zero())
| Constructs a constraint interval that will constrain the position of one node to the position of another.
virtual TypeHandle | force_init_type ()
const NodePath & | get_node () const
| Returns the "source" node.
const NodePath & | get_target () const
| Returns the "target" node.
virtual TypeHandle | get_type () const
virtual void | output (std::ostream &out) const
virtual void | priv_step (double t)
| Advances the time on the interval.
Public Member Functions inherited from CConstraintInterval
| CConstraintInterval (const std::string &name, double duration)
Public Member Functions inherited from CInterval
| CInterval (const std::string &name, double duration, bool open_ended)
bool | check_t_callback ()
| Returns true if the wants_t_callback() flag is true and the interval's t value has changed since the last call to check_t_callback(), false otherwise.
void | clear_to_initial ()
| Pauses the interval, if it is playing, and resets its state to its initial state, abandoning any state changes already in progress in the middle of the interval.
void | finish ()
| Stops the interval from playing and sets it to its final state.
bool | get_auto_finish () const
bool | get_auto_pause () const
const std::string & | get_done_event () const
double | get_duration () const
CIntervalManager * | get_manager () const
const std::string & | get_name () const
bool | get_open_ended () const
double | get_play_rate () const
State | get_state () const
double | get_t () const
bool | get_wants_t_callback () const
| Returns the state of the 'wants_t_callback' flag.
bool | is_playing () const
bool | is_stopped () const
void | loop (double start_t=0.0, double end_t=-1.0, double play_rate=1.0)
| Starts the interval playing by registering it with the current CIntervalManager.
void | mark_dirty ()
| Called by a derived class to indicate the interval has been changed internally and must be recomputed before its duration may be returned.
double | pause ()
| Stops the interval from playing but leaves it in its current state.
void | priv_do_event (double t, EventType event)
| Calls the appropriate event function indicated by the EventType.
virtual void | priv_finalize ()
| This is called to stop an interval, forcing it to whatever state it would be after it played all the way through.
virtual void | priv_initialize (double t)
| This replaces the first call to priv_step(), and indicates that the interval has just begun.
virtual void | priv_instant ()
| This is called in lieu of priv_initialize() .
virtual void | priv_interrupt ()
| This is called while the interval is playing to indicate that it is about to be interrupted; that is, priv_step() will not be called for a length of time.
virtual void | priv_reverse_finalize ()
| Called generally following a priv_reverse_initialize(), this indicates the interval should set itself to the initial state.
virtual void | priv_reverse_initialize (double t)
| Similar to priv_initialize(), but this is called when the interval is being played backwards; it indicates that the interval should start at the finishing state and undo any intervening intervals.
virtual void | priv_reverse_instant ()
| This is called in lieu of priv_reverse_initialize() .
void | resume ()
| Restarts the interval from its current point after a previous call to pause().
void | resume (double start_t)
| Restarts the interval from the indicated point after a previous call to pause().
void | resume_until (double end_t)
| Restarts the interval from the current point after a previous call to pause() (or a previous play-to-point-and-stop), to play until the indicated point and then stop.
void | set_auto_finish (bool auto_finish)
void | set_auto_pause (bool auto_pause)
void | set_done_event (const std::string &event)
void | set_manager (CIntervalManager *manager)
void | set_play_rate (double play_rate)
void | set_t (double t)
void | set_wants_t_callback (bool wants_t_callback)
| Changes the state of the 'wants_t_callback' flag.
void | setup_play (double start_time, double end_time, double play_rate, bool do_loop)
| Called to prepare the interval for automatic timed playback, e.g.
void | setup_resume ()
| Called to prepare the interval for restarting at the current point within the interval after an interruption.
void | setup_resume_until (double end_t)
| Called to prepare the interval for restarting from the current point after a previous call to pause() (or a previous play-to-point-and-stop), to play until the indicated point and then stop.
void | start (double start_t=0.0, double end_t=-1.0, double play_rate=1.0)
| Starts the interval playing by registering it with the current CIntervalManager.
bool | step_play ()
| Should be called once per frame to execute the automatic timed playback begun with setup_play().
virtual void | write (std::ostream &out, int indent_level) const
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from CConstraintInterval
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from CInterval
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from CInterval
enum | EventType { ET_initialize , ET_instant , ET_step , ET_finalize , ET_reverse_initialize , ET_reverse_instant , ET_reverse_finalize , ET_interrupt }
enum | State { S_initial , S_started , S_paused , S_final }
Public Attributes inherited from CConstraintInterval
bool | bogus_variable
Public Attributes inherited from CInterval
| get_auto_finish
| Returns the state of the 'auto_finish' flag.
| get_auto_pause
| Returns the state of the 'auto_pause' flag.
| get_done_event
| Returns the event that is generated whenever the interval reaches its final state, whether it is explicitly finished or whether it gets there on its own.
| get_duration
| Returns the duration of the interval in seconds.
| get_manager
| Returns the CIntervalManager object which will be responsible for playing this interval.
| get_name
| Returns the interval's name.
| get_open_ended
| Returns the state of the "open_ended" flag.
| get_play_rate
| Returns the play rate as set by the last call to start(), loop(), or set_play_rate().
| get_state
| Indicates the state the interval believes it is in: whether it has been started, is currently in the middle, or has been finalized.
| get_t
| Returns the current time of the interval: the last value of t passed to priv_initialize(), priv_step(), or priv_finalize().
| is_playing
| Returns true if the interval is currently playing, false otherwise.
| is_stopped
| Returns true if the interval is in either its initial or final states (but not in a running or paused state).
| set_auto_finish
| Changes the state of the 'auto_finish' flag.
| set_auto_pause
| Changes the state of the 'auto_pause' flag.
| set_done_event
| Sets the event that is generated whenever the interval reaches its final state, whether it is explicitly finished or whether it gets there on its own.
| set_manager
| Indicates the CIntervalManager object which will be responsible for playing this interval.
| set_play_rate
| Changes the play rate of the interval.
| set_t
| Explicitly sets the time within the interval.
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

A constraint interval that will constrain the position of one node to the position of another.

Definition at line 26 of file cConstrainPosInterval.h.

## Constructor & Destructor Documentation

## ◆ CConstrainPosInterval()

CConstrainPosInterval::CConstrainPosInterval | ( | const std::string & | name,
|  | double | duration,
|  | const NodePath & | node,
|  | const NodePath & | target,
|  | bool | wrt,
|  | const LVecBase3 | posOffset = LVector3::zero() )
| explicit

Constructs a constraint interval that will constrain the position of one node to the position of another.

If wrt is true, the node's position will be transformed into the target node's parent's space before being copied. If wrt is false, the target node's local position will be copied unaltered.

Definition at line 28 of file cConstrainPosInterval.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle CConstrainPosInterval::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from CConstraintInterval.

Definition at line 56 of file cConstrainPosInterval.h.

## ◆ get_class_type()

static TypeHandle CConstrainPosInterval::get_class_type | ( |  | ) |
| inline static

Definition at line 45 of file cConstrainPosInterval.h.

## ◆ get_node()

const NodePath & CConstrainPosInterval::get_node | ( |  | ) | const
| inline

Returns the "source" node.

Definition at line 17 of file cConstrainPosInterval.I.

## ◆ get_target()

const NodePath & CConstrainPosInterval::get_target | ( |  | ) | const
| inline

Returns the "target" node.

Definition at line 25 of file cConstrainPosInterval.I.

## ◆ get_type()

virtual TypeHandle CConstrainPosInterval::get_type | ( |  | ) | const
| inline virtual

Reimplemented from CConstraintInterval.

Definition at line 53 of file cConstrainPosInterval.h.

## ◆ init_type()

static void CConstrainPosInterval::init_type | ( |  | ) |
| inline static

Definition at line 48 of file cConstrainPosInterval.h.

## ◆ output()

void CConstrainPosInterval::output | ( | std::ostream & | out | ) | const
| virtual

Reimplemented from CInterval.

Definition at line 75 of file cConstrainPosInterval.cxx.

## ◆ priv_step()

void CConstrainPosInterval::priv_step | ( | double | t | ) |
| virtual

Advances the time on the interval.

The time may either increase (the normal case) or decrease (e.g. if the interval is being played by a slider).

Reimplemented from CInterval.

Definition at line 45 of file cConstrainPosInterval.cxx.

The documentation for this class was generated from the following files:

- direct/src/interval/cConstrainPosInterval.h
- direct/src/interval/cConstrainPosInterval.cxx
- direct/src/interval/cConstrainPosInterval.I